(function() {
  module.exports = function() {
    var docs;
    docs = {};
    return {
      getOps: function(docName, start, end, callback) {
        var ops, _ref;
        ops = (_ref = docs[docName]) != null ? _ref.ops : void 0;
        if (ops != null) {
          end != null ? end : end = ops.length;
          return callback(ops.slice(start, end));
        } else {
          return callback([]);
        }
      },
      append: function(docName, op_data, doc_data, callback) {
        var doc, new_op_data;
        if (doc_data.snapshot === void 0) {
          throw new Error('snapshot missing from data');
        }
        if (doc_data.type === void 0) {
          throw new Error('type missing from data');
        }
        doc = docs[docName] || (docs[docName] = {
          ops: [],
          data: null
        });
        if (op_data.v !== doc.ops.length) {
          throw new Error('Version mismatch in db.append');
        }
        new_op_data = {
          op: op_data.op,
          v: op_data.v
        };
        if (op_data.meta != null) {
          new_op_data.meta = op_data.meta;
        }
        doc.ops.push(new_op_data);
        doc.data = doc_data;
        return callback();
      },
      getSnapshot: function(docName, callback) {
        var doc;
        doc = docs[docName];
        if (doc != null) {
          return callback({
            v: doc.ops.length,
            type: doc.data.type,
            snapshot: doc.data.snapshot
          });
        } else {
          return callback({
            v: 0,
            type: null,
            snapshot: null
          });
        }
      },
      getVersion: function(docName, callback) {
        var _ref;
        return callback(((_ref = docs[docName]) != null ? _ref.ops.length : void 0) || 0);
      },
      "delete": function(docName, callback) {
        if (docs[docName] != null) {
          delete docs[docName];
          if (callback != null) {
            return callback(true);
          }
        } else {
          if (callback != null) {
            return callback(false);
          }
        }
      },
      close: function() {}
    };
  };
}).call(this);
