(function() {
  var Db, Model, attach, connect, create, createModel, rest, socketio;
  connect = require('connect');
  Model = require('./model');
  Db = require('./db');
  rest = require('./rest');
  socketio = require('./socketio');
  module.exports = create = function(options, model) {
    if (model == null) {
      model = createModel(options);
    }
    return attach(connect(), options, model);
  };
  create.createModel = createModel = function(options) {
    var db, dbOptions;
    dbOptions = options != null ? options.db : void 0;
    db = new Db(dbOptions);
    return new Model(db);
  };
  create.attach = attach = function(server, options, model) {
    if (model == null) {
      model = createModel(options);
    }
    server.model = model;
    if ((options != null ? options.rest : void 0) !== null) {
      server.use(rest(model, options != null ? options.rest : void 0));
    }
    if ((options != null ? options.socketio : void 0) !== null) {
      socketio.attach(server, model, options != null ? options.socketio : void 0);
    }
    return server;
  };
}).call(this);
