(function() {
  var applyOps, i, p, transformX;
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };
  p = function() {};
  i = function() {};
  exports.transformX = transformX = function(type, server, client) {
    return [type.transform(server, client, 'server'), type.transform(client, server, 'client')];
  };
  exports.transformLists = function(type, serverOps, clientOps) {
    var c, c_, s;
    serverOps = (function() {
      var _i, _len, _results;
      _results = [];
      for (_i = 0, _len = serverOps.length; _i < _len; _i++) {
        s = serverOps[_i];
        clientOps = (function() {
          var _i, _len, _ref, _results;
          _results = [];
          for (_i = 0, _len = clientOps.length; _i < _len; _i++) {
            c = clientOps[_i];
            _ref = transformX(type, s, c), s = _ref[0], c_ = _ref[1];
            _results.push(c_);
          }
          return _results;
        })();
        _results.push(s);
      }
      return _results;
    })();
    return [serverOps, clientOps];
  };
  exports.composeList = function(type, ops) {
    var op, result, _i, _len;
    result = null;
    for (_i = 0, _len = ops.length; _i < _len; _i++) {
      op = ops[_i];
      if (result === null) {
        result = op;
      } else {
        result = type.compose(result, op);
      }
    }
    return result;
  };
  exports.makePassPart = function(test, n) {
    var remaining;
    remaining = n;
    return function() {
      remaining--;
      if (remaining === 0) {
        return test.done();
      } else if (remaining < 0) {
        throw new Error("passPart() called more than " + n + " times");
      }
    };
  };
  exports.applyOps = applyOps = __bind(function(model, docName, startVersion, ops, callback) {
    var op;
    op = ops.shift();
    return model.applyOp(docName, {
      v: startVersion,
      op: op
    }, __bind(function(error, appliedVersion) {
      if (error) {
        return callback(error, null);
      } else {
        if (ops.length === 0) {
          return model.getSnapshot(docName, function(snapshot) {
            return callback(null, snapshot);
          });
        } else {
          return applyOps(model, docName, startVersion + 1, ops, callback);
        }
      }
    }, this));
  }, this);
  exports.newDocName = (function() {
    var index;
    index = 1;
    return function() {
      return 'testing_doc_' + index++;
    };
  })();
}).call(this);
