(function() {
  var assert, helpers, i, p, testRandomOp, util;
  assert = require('assert');
  helpers = require('./misc');
  util = require('util');
  p = util.debug;
  i = util.inspect;
  testRandomOp = function(type, initialDoc) {
    var c_, c_inv, c_s, client, client_, compose, doc, makeDoc, op, orig_, s_, s_c, server, server_, server_result_, testApply, testInvert, _i, _ref, _ref2, _ref3, _ref4;
    if (initialDoc == null) {
      initialDoc = type.initialVersion();
    }
    makeDoc = function() {
      return {
        ops: [],
        result: initialDoc
      };
    };
    server = makeDoc();
    client = makeDoc();
    for (_i = 0, _ref = Math.random() * 2 + 1; (0 <= _ref ? _i <= _ref : _i >= _ref); (0 <= _ref ? _i += 1 : _i -= 1)) {
      doc = Math.random() < 0.5 ? client : server;
      _ref2 = type.generateRandomOp(doc.result), op = _ref2[0], doc.result = _ref2[1];
      doc.ops.push(op);
    }
    testApply = function(doc) {
      var op, s, _i, _len, _ref;
      s = initialDoc;
      _ref = doc.ops;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        op = _ref[_i];
        s = type.apply(s, op);
      }
      return assert.deepEqual(s, doc.result);
    };
    testApply(client);
    testApply(server);
    if (type.invert != null) {
      testInvert = function(doc, ops) {
        var op, op_, snapshot, _i, _len;
        snapshot = doc.result;
        ops = ops.slice().reverse();
        for (_i = 0, _len = ops.length; _i < _len; _i++) {
          op = ops[_i];
          op_ = type.invert(op);
          snapshot = type.apply(snapshot, op_);
        }
        return assert.deepEqual(snapshot, initialDoc);
      };
    }
    if (typeof testInvert == "function") {
      testInvert(client, client.ops);
    }
    if (typeof testInvert == "function") {
      testInvert(server, server.ops);
    }
    if (type.compose != null) {
      compose = function(doc) {
        if (doc.ops.length > 0) {
          doc.composed = helpers.composeList(type, doc.ops);
          return assert.deepEqual(doc.result, type.apply(initialDoc, doc.composed));
        }
      };
      compose(client);
      compose(server);
      if (client.composed != null) {
        if (typeof testInvert == "function") {
          testInvert(client, [client.composed]);
        }
      }
      if (server.composed != null) {
        if (typeof testInvert == "function") {
          testInvert(server, [server.composed]);
        }
      }
      if ((client.composed != null) && (server.composed != null)) {
        _ref3 = helpers.transformX(type, server.composed, client.composed), server_ = _ref3[0], client_ = _ref3[1];
        s_c = type.apply(server.result, client_);
        c_s = type.apply(client.result, server_);
        assert.deepEqual(s_c, c_s);
      }
    }
    if (client.ops.length > 0 && server.ops.length > 0) {
      _ref4 = helpers.transformLists(type, server.ops, client.ops), s_ = _ref4[0], c_ = _ref4[1];
      s_c = c_.reduce(type.apply, server.result);
      c_s = s_.reduce(type.apply, client.result);
      assert.deepEqual(s_c, c_s);
      if (type.invert != null) {
        c_inv = c_.slice().reverse().map(type.invert);
        server_result_ = c_inv.reduce(type.apply, s_c);
        assert.deepEqual(server.result, server_result_);
        orig_ = server.ops.slice().reverse().map(type.invert).reduce(type.apply, server_result_);
        assert.deepEqual(orig_, initialDoc);
      }
    }
    return client.result;
  };
  exports.test = function(type, iterations) {
    var doc, n, warnUnless, _results;
    if (iterations == null) {
      iterations = 300;
    }
    assert.ok(type.generateRandomOp);
    assert.ok(type.transform);
    p("   Running " + iterations + " of randomized tests for type " + type.name + "...");
    warnUnless = function(fn) {
      if (type[fn] == null) {
        return p("NOTE: Not running " + fn + " tests because " + type.name + " does not have " + fn + "() defined");
      }
    };
    warnUnless('invert');
    warnUnless('compose');
    doc = type.initialVersion();
    _results = [];
    for (n = 0; (0 <= iterations ? n <= iterations : n >= iterations); (0 <= iterations ? n += 1 : n -= 1)) {
      _results.push(doc = testRandomOp(type, doc));
    }
    return _results;
  };
}).call(this);
